/* Sistemas Integrados TECNISA

Nome: 0209_GERTRG_GRAVA_DTENTRSOL.SQL

Descrio:
Trigger para atualizao do campo DTENTRITMSOL da tabela ITEMAUTF.

Criao:
12/04/2003 Marcelo Alexsandro Souza Silva
*/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE 
            o.name = 'GRAVA_DTENTRSOL'  and 
            type = 'TR'                 and
            u.uid = o.uid               and 
            u.name = USER)
  DROP TRIGGER GRAVA_DTENTRSOL
  GO


CREATE TRIGGER GRAVA_DTENTRSOL
ON ITEMAUTF
FOR INSERT
AS
BEGIN
   UPDATE ITEMAUTF
   SET DTENTRITMSOL = INSERTED.DTPROGENTAF
   FROM INSERTED
   WHERE ITEMAUTF.CDFILDEST   = INSERTED.CDFILDEST   AND
         ITEMAUTF.CDFILLANC   = INSERTED.CDFILLANC   AND
         ITEMAUTF.NRAUTOFORN  = INSERTED.NRAUTOFORN  AND
         ITEMAUTF.CDMARCA     = INSERTED.CDMARCA     AND
         ITEMAUTF.CDPRODUTO   = INSERTED.CDPRODUTO   AND
         ITEMAUTF.DTPROGENTAF = INSERTED.DTPROGENTAF AND
         ITEMAUTF.DTENTRITMSOL IS NULL;
END;
GO