create or replace TRIGGER LOG_GOP_DEDURECEITAROP
AFTER INSERT
ON DEDURECEITAROP FOR EACH ROW
DECLARE
  V_TIPO                VARCHAR2(1);
  V_DSREMOTEADDR        VARCHAR2(15);
  V_DSREMOTEHOST        VARCHAR2(15);
  V_DSSERVERRDM         VARCHAR2(100);
  V_DSSERVMETHOD        VARCHAR2(4000);
  V_DSREMOTEOPER        VARCHAR2(12);
  V_DESC                VARCHAR2(500);
  V_DESCUPD             VARCHAR2(200);
  V_CDFILLOGOPER        VARCHAR2(4);
  V_ITPESQ              VARCHAR2(40);
  V_NMOPERADOR          VARCHAR2(40);
  V_CDOPERADOR          VARCHAR2(12);
  V_CDFILIAL            VARCHAR2(20);
  V_NMFILIAL            VARCHAR2(50);
  V_NMENCARGO           VARCHAR2(100);
  V_NMTIPOOPER          VARCHAR2(100);
  V_UNIDADE             VARCHAR2(100);


BEGIN
/* IDTIPOOPER - '1' - Inclusao, '2' - Alteracao, '3' - Exclusao*/
   V_TIPO         := '0';
   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';
   V_DESCUPD      := '';
   V_CDOPERADOR   := :NEW.CDOPERULTATU;
   V_CDFILLOGOPER := '';

   NMOPERADOR(V_CDOPERADOR, V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

    V_DSSERVERRDM := 'ger80200_parametros_resultado_operacional';

    IF INSERTING THEN
        V_TIPO         := '1';
        V_ITPESQ       := TO_CHAR(NVL(:NEW.CDFILIAL, ' ')) || '|' || TO_CHAR(NVL(:NEW.CDENCARGO, ' '));
        V_DESCUPD := 'Parametros para Resultado Operacional' || chr(10);
        
        IF TO_CHAR(:NEW.CDFILIAL) = 'T' OR TO_CHAR(:NEW.CDFILIAL) =  'P' THEN
            V_UNIDADE   := chr(10) || chr(10) || 'Unidade: Padrao';
        ELSE
            SELECT MAX(CDFILIAL), MAX(NMFILIAL) INTO V_CDFILIAL, V_NMFILIAL FROM FILIAL WHERE CDFILIAL = :NEW.CDFILIAL;
            V_UNIDADE   := chr(10) || chr(10) || 'Unidade: '|| V_CDFILIAL || ' - ' || V_NMFILIAL;
        END IF;


        IF NOT :NEW.CDENCARGO IS NULL THEN

            SELECT MAX(NMENCARGO) INTO V_NMENCARGO FROM ENCARGO WHERE CDENCARGO = :NEW.CDENCARGO;
            V_DESC := '-> Deducoes e Receitas -> Descontos sobre Vendas' || V_UNIDADE || chr(10) || 'Desconto: ' || :NEW.CDENCARGO || ' - ' || V_NMENCARGO;

        ELSIF NOT :NEW.CDTIPOOPER IS NULL THEN

            SELECT MAX(NMTIPOOPER) INTO V_NMTIPOOPER FROM TIPOOPERAC WHERE CDTIPOOPER = :NEW.CDTIPOOPER AND IDENTRSAIDOP = :NEW.IDENTRSAIDOP;
            V_DESC := '-> Deducoes e Receitas -> Devolucoes / Estornos ' || V_UNIDADE || chr(10) || 'Devolucao / Estorno: ' || :NEW.CDTIPOOPER || ' - ' || V_NMTIPOOPER;

        END IF;

    END IF;

    IF NOT V_DESC IS NULL THEN
      V_DESC := V_DESCUPD || V_DESC;
      INSERT INTO LOGOPERAGES
        (NMTABELA,     DTOPERACAO,   NMRESPOPER,  IDTIPOOPER,   DSOPERACAO,  CDPESQITEM,
         DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
      VALUES
        ('DEDURECEITAROP', SYSDATE, NVL(V_NMOPERADOR,' '), V_TIPO, V_DESC, V_ITPESQ, NVL(V_DSSERVERRDM, ' '), 
          NVL(V_DSREMOTEADDR, ' '), NVL(V_DSREMOTEHOST, ' '), NVL(V_DSSERVMETHOD, ' '), NVL(V_CDOPERADOR, ' '),
          NVL(V_CDFILLOGOPER, ' '));
    END IF;
END;